GEGELATI

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
Learn::AdversarialEvaluationResult Class Reference

Class for storing all results of a policy evaluation in in adversarial mode with an AdversarialLearningEnvironment. More...

`#include <adversarialEvaluationResult.h>`

Inheritance diagram for Learn::AdversarialEvaluationResult:

## Public Member Functions
| AdversarialEvaluationResult (std::initializer_list< double > res, size_t nbEval=1)
| Base constructor of EvaluationResult, allowing to set scores and the number of evaluations.
| AdversarialEvaluationResult (size_t size, size_t nbEval=0)
| Constructor initializing scores as empty.
double | getScoreOf (int index)
| Simple getter of the score of a single root, given its index.
EvaluationResult & | operator+= (const EvaluationResult &other) override
| Polymorphic addition assignement operator for AdversariEalvaluationResult.
virtual EvaluationResult & | operator/= (double divisor)
| Division operator for AdversarialEvaluationResult that simply divides all scores contained in the scores vector by divisor.
double | getResult () const override
| Returns the mean of the scores, used for example in a simple learning agent as the root will play against itself. In this situation getting the mean of the scores would be relevant.
size_t | getSize () const
| Getter fot the size of scores.
Public Member Functions inherited from Learn::EvaluationResult
| EvaluationResult ()=delete
| Deleted default constructor.
virtual | ~EvaluationResult ()=default
| Virtual destructor for polymorphism.
| EvaluationResult (const double &res, const size_t &nbEval, const double &uti=std::nan(""))
| Construct a result from a simple double value.
virtual double | getUtility () const
| Virtual method to get the default double equivalent of the utility of the EvaluationResult.
virtual size_t | getNbEvaluation () const
| Virtual method to get the default number of evaluation of the EvaluationResult.

## Protected Attributes
std::vector< double > | scores
| The scores of the roots, in the order in which they participated.
Protected Attributes inherited from Learn::EvaluationResult
double | result
| Double value for the result.
double | utility
size_t | nbEvaluation
| Number of evaluation leading to this result.

## Detailed Description

Class for storing all results of a policy evaluation in in adversarial mode with an AdversarialLearningEnvironment.

The main difference with the base EvaluationResult class is that there are several results. Indeed, in adversarial mode there are several roots in a single simulation and, as a consequence, there are several results at the end.

## Constructor & Destructor Documentation

## ◆ AdversarialEvaluationResult() [1/2]

Learn::AdversarialEvaluationResult::AdversarialEvaluationResult | ( | std::initializer_list< double > | res,
|  | size_t | nbEval = 1 )
| inline

Base constructor of EvaluationResult, allowing to set scores and the number of evaluations.

Parameters

  [in] | res | The scores of the roots in the order.
  [in] | nbEval | The number of evaluations that have been done to get these scores. Default is 1 as we can guess user only did 1 iteration.

## ◆ AdversarialEvaluationResult() [2/2]

Learn::AdversarialEvaluationResult::AdversarialEvaluationResult | ( | size_t | size,
|  | size_t | nbEval = 0 )
| inline

Constructor initializing scores as empty.

Parameters

  [in] | size | The size of scores i.e. number of evaluated agents.
  [in] | nbEval | The number of evaluations that have been done to get these scores. Default is 0, as we have no score, we have no eval.

## Member Function Documentation

## ◆ getResult()

double Learn::AdversarialEvaluationResult::getResult | ( |  | ) | const
| override virtual

Returns the mean of the scores, used for example in a simple learning agent as the root will play against itself. In this situation getting the mean of the scores would be relevant.

Returns
  The mean of the scores contained in this object.

Reimplemented from Learn::EvaluationResult.

## ◆ getScoreOf()

double Learn::AdversarialEvaluationResult::getScoreOf | ( | int | index | ) |

Simple getter of the score of a single root, given its index.

Parameters

  [in] | index | The index of the root in the results list.

Returns
  The score corresponding to this index.

Copyright or © or Copr. IETR/INSA - Rennes (2019 - 2020) :

Karol Desnos kdesn.nosp@m.os@i.nosp@m.nsa-r.nosp@m.enne.nosp@m.s.fr (2019 - 2020) Pierre-Yves Le Rolland-Raumer plero.nosp@m.lla@.nosp@m.insa-.nosp@m.renn.nosp@m.es.fr (2020)

GEGELATI is an open-source reinforcement learning framework for training artificial intelligence based on Tangled Program Graphs (TPGs).

This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software. You can use, modify and/ or redistribute the software under the terms of the CeCILL-C license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".

As a counterpart to the access to the source code and rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty and the software's author, the holder of the economic rights, and the successive licensors have only limited liability.

In this respect, the user's attention is drawn to the risks associated with loading, using, modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean that it is complicated to manipulate, and that also therefore means that it is reserved for developers and experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or data to be ensured and, more generally, to use and operate it in the same conditions as regards security.

The fact that you are presently reading this means that you have had knowledge of the CeCILL-C license and that you accept its terms.

## ◆ getSize()

size_t Learn::AdversarialEvaluationResult::getSize | ( |  | ) | const

Getter fot the size of scores.

Returns
  The size of the scores vector.

## ◆ operator+=()

Learn::EvaluationResult & Learn::AdversarialEvaluationResult::operator+= | ( | const EvaluationResult & | other | ) |
| override virtual

Polymorphic addition assignement operator for AdversariEalvaluationResult.

Parameters

  [in] | other | The other evaluation result we add to this one.

Returns
  This AdversarialEvaluationResult.

Exceptions

  std::runtime_error | in case the other AdversarialEvaluationResult and this have a different typeid or size.

Reimplemented from Learn::EvaluationResult.

## ◆ operator/=()

Learn::EvaluationResult & Learn::AdversarialEvaluationResult::operator/= | ( | double | divisor | ) |
| virtual

Division operator for AdversarialEvaluationResult that simply divides all scores contained in the scores vector by divisor.

Parameters

  [in] | divisor | The divisor by which we will divide the results.

Returns
  This AdversarialEvaluationResult.

The documentation for this class was generated from the following files:

- D:/a/gegelati/gegelati/gegelatilib/include/learn/adversarialEvaluationResult.h
- D:/a/gegelati/gegelati/gegelatilib/src/learn/adversarialEvaluationResult.cpp